/* ERR String definitions
 * 
 * NOTE: When adding a new error, please check that the PKI_ERR_
 *       and the corresponding string description match the error!
 */

#ifndef _LIBPKI_ERR_H
#define _LIBPKI_ERR_H

typedef enum {
	PKI_ERR_UNKNOWN 	= 0,
	PKI_ERR_MEMORY,
	PKI_ERR_OFILE
} PKI_ERRORS;


/* We define the actual object of strings only if we are compiling
 * the pki_err.c file where __LIBPKI_ERR__ is defined */
#ifdef __LIBPKI_ERR__
static char * pki_errval_strings[] = {
/* 0  */ "General Error",
/* 1  */ "Memory Allocation Error",
/* 2  */ "File Open Error",
/* 3  */ "",
/* 4  */ "",
/* 5  */ "",
/* 6  */ "",
/* 7  */ "",
/* 8  */ "",
/* 9  */ "",
/* 10 */ "",
/* 11 */ "",
/* 12 */ "",
/* 13 */ "",
/* 14 */ "",
/* 15 */ "",
/* 16 */ "",
};

#endif /* __LIBPKI_ERR__ */

int PKI_set_errno ( int err );
int PKI_get_errno ( void );

char * PKI_get_strerror ( void );

#endif
