/* openca/pkicrypto/url.h */
/*
 * LIBPKI - OpenSource PKI library
 * by Massimiliano Pala (madwolf@openca.org) and OpenCA project
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */


#ifndef _LIBPKI_URL_HTTP_H
#define _LIBPKI_URL_HTTP_H

#include <libpki/pki_mem.h>
#include <libpki/net/url.h>
#include <libpki/stack.h>

#define PKI_HTTP_METHOD_POST		0
#define PKI_HTTP_METHOD_GET		1
#define PKI_HTTP_METHOD_POST_TXT	"POST"
#define PKI_HTTP_METHOD_GET_TXT		"GET"

#define LIBPKI_HTTP_BUF_SIZE		8192

/* Function prototypes */
HTTP_RV *parse_http_headers_mem ( PKI_MEM *pki_mem );

PKI_MEM *http_get_data_sock ( int fd, int timeout, ssize_t max_size );

int URL_get_data_http_url ( URL *url, char *data, ssize_t data_size,
			int method, char *content, PKI_MEM_STACK **sk,
					int timeout, ssize_t max_size );

PKI_MEM_STACK *URL_get_data_http ( char *url_s, int timeout, ssize_t max_size );

int URL_post_data_http ( char *url_s, char *data, ssize_t size,
                                char *content_type, PKI_MEM_STACK **ret_sk,
                                        int timeout, ssize_t max_size );
int URL_post_data_http_url ( URL *url, char *data, ssize_t size,
                                char *content_type, PKI_MEM_STACK **ret_sk,
                                        int timeout, ssize_t max_size );

#endif
