/* openca/pkicrypto/url.h */
/*
 * LIBPKI - OpenSource PKI library
 * by Massimiliano Pala (madwolf@openca.org) and OpenCA project
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */


#ifndef _LIBPKI_URL_HTTPS_H
#define _LIBPKI_URL_HTTPS_H

#include <libpki/pki_mem.h>
#include <libpki/net/url.h>
#include <openssl/ssl.h>

#define HTTPS_POST			0
#define HTTPS_GET			1
#define HTTPS_POST_METHOD		"POST"
#define HTTPS_GET_METHOD		"GET"

#define LIBPKI_HTTPS_BUF_SIZE		8192

/* SSL helper functions */
SSL *PKI_SSL_new ( URL *url );
int PKI_SSL_free ( SSL *ssl );

PKI_MEM *https_get_data_sock ( SSL *ssl, ssize_t max_size );

/* Function prototypes */
PKI_MEM_STACK *URL_get_data_https ( char *url_s, ssize_t max_size );
PKI_MEM_STACK *URL_get_data_https_url ( URL *url, ssize_t max_size );

int URL_post_data_https ( char *url_s, char *data, ssize_t size, 
				char *content_type, PKI_MEM_STACK **ret_sk );
int URL_post_data_https_url ( URL *url, char *data, ssize_t size, 
				char *content_type, PKI_MEM_STACK **ret_sk );


#endif
